/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.cmd;

import net.minecraft.block.Block;
import net.minecraft.block.BlockDynamicLiquid;
import net.minecraft.block.BlockStaticLiquid;
import net.minecraft.block.state.IBlockState;
import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.command.WrongUsageException;
import net.minecraft.init.Blocks;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.world.World;
import net.minecraftforge.fluids.BlockFluidBase;

import net.dries007.tfc.objects.blocks.stone.BlockRockVariant;

public class StripWorldCommand extends CommandBase
{
    @Override
    public String func_71517_b()
    {
        return "stripworld";
    }

    @Override
    public String func_71518_a(ICommandSender sender)
    {
        return "/stripworld <radius> -> [DANGER] Strips all stone variant blocks + water.";
    }

    @Override
    public void func_184881_a(MinecraftServer server, ICommandSender sender, String[] args) throws CommandException
    {
        if (args.length != 1) throw new WrongUsageException("1 argument required.");
        int radius = func_175764_a(args[0], 1, 250);

        if (sender.func_174793_f() == null) return;

        final World world = sender.func_130014_f_();
        final BlockPos center = new BlockPos(sender.func_174793_f());

        final IBlockState fluidReplacement = Blocks.field_150359_w.func_176223_P();
        final IBlockState terrainReplacement = Blocks.field_150350_a.func_176223_P();

        for (int x = -radius; x < radius; x++)
        {
            for (int z = -radius; z < radius; z++)
            {
                for (int y = 255 - center.func_177956_o(); y > -center.func_177956_o(); y--)
                {
                    final BlockPos pos = center.func_177982_a(x, y, z);
                    final Block current = world.func_180495_p(pos).func_177230_c();
                    if (current instanceof BlockFluidBase)
                        world.func_180501_a(pos, fluidReplacement, 2);
                    else if (current instanceof BlockDynamicLiquid || current instanceof BlockStaticLiquid)
                        world.func_180501_a(pos, fluidReplacement, 2);
                    else if (current instanceof BlockRockVariant)
                        world.func_180501_a(pos, terrainReplacement, 2);
                }
            }
        }


        sender.func_145747_a(new TextComponentString("Done."));
    }
}
