/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic.genlayers.biome;

import net.minecraft.world.biome.Biome;
import net.minecraft.world.gen.layer.GenLayer;
import net.minecraft.world.gen.layer.IntCache;

import net.dries007.tfc.objects.biomes.BiomeTFC;
import net.dries007.tfc.objects.biomes.BiomesTFC;
import net.dries007.tfc.world.classic.genlayers.GenLayerTFC;

public class GenLayerBiomeTFC extends GenLayerTFC
{
    private final BiomeTFC[] biomes;

    public GenLayerBiomeTFC(long seed, GenLayer parent)
    {
        super(seed);
        this.field_75909_a = parent;

        biomes = BiomesTFC.getOverworldGenerateBiomes();
    }

    @Override
    public int[] func_75904_a(int par1, int par2, int par3, int par4)
    {
        int[] var5 = field_75909_a.func_75904_a(par1, par2, par3, par4);
//        validateIntArray(var5, par3, par4);
        int[] var6 = IntCache.func_76445_a(par3 * par4);

        for (int var7 = 0; var7 < par4; ++var7)
        {
            for (int var8 = 0; var8 < par3; ++var8)
            {
                func_75903_a(var8 + par1, var7 + par2);
                int id = var5[var8 + var7 * par3];
                if (BiomesTFC.isOceanicBiome(id)) var6[var8 + var7 * par3] = id;
                else var6[var8 + var7 * par3] = Biome.func_185362_a(biomes[func_75902_a(biomes.length)]);
            }
        }
        return var6;
    }
}
